import random

# play as a submarine
def submarine(ship_count, sub_count, radius_move, radius_view, radius_attack, game_map):
    vessels = []
    used = [[False] * len(game_map[0]) for _ in range(len(game_map))]
    init_positions(game_map, used, vessels, 'd', sub_count)
    while True:
        # read input (visible ships)
        visible_ship_count = int(input())
        if visible_ship_count < 0:
            break
        visible_ships = [map(int, input().split(' ')) for _ in range(visible_ship_count)]
        used = [[False] * len(game_map[0]) for _ in range(len(game_map))]
        # update the map of used positions
        for x, y, destroyed, arrived in vessels:
            if not destroyed and not arrived:
                used[y][x] = True
        # play for each vessel
        for vessel in vessels:
            if vessel[2] or vessel[3]:
                continue
            # TODO: edit this section with your strategy
            # check if a ship is within reach
            found = False
            for x, y in visible_ships:
                if dist2(vessel[0], vessel[1], x, y) <= radius_attack:
                    print("A", x, y)
                    found = True
                    break
            if found:
                continue

            # if no ship to attack is within reach move to a random nearby position
            possibles = get_matching_positions(game_map, used, '#', False)
            possible_moves = [move for move in possibles if dist2(move[0], move[1], vessel[0], vessel[1]) <= radius_move]
            # move vessel
            if len(possible_moves) > 0:
                position = random.choice(possible_moves)
                used[vessel[1]][vessel[0]] = False
                used[position[1]][position[0]] = True
                vessel[0], vessel[1] = position
            # TODO: end of section
            # output move
            print("M", vessel[0], vessel[1])

# play as a ship
def ship(ship_count, sub_count, radius_move, radius_view, radius_attack, game_map):
    vessels = []
    used = [[False] * len(game_map[0]) for _ in range(len(game_map))]
    init_positions(game_map, used, vessels, 's', ship_count)
    while True:
        # read input (visible ships)
        sunken_ships_count = int(input())
        if sunken_ships_count < 0:
            break
        sunken_ships = [map(int, input().split(' ')) for _ in range(sunken_ships_count)]
        for xsh, ysh, xsu, ysu in sunken_ships:
            for vessel in vessels:
                if vessel[0] == xsh and vessel[1] == ysh:
                    vessel[2] = True
        used = [[False] * len(game_map[0]) for _ in range(len(game_map))]
        # update the map of used positions
        for x, y, destroyed, arrived in vessels:
            if not destroyed and not arrived:
                used[y][x] = True
        # play for each vessel
        for vessel in vessels:
            if vessel[2] or vessel[3]:
                continue
            # TODO: edit this section with your strategy
            # move to a random position
            possibles = get_matching_positions(game_map, used, '#', False)
            # TODO wtf None
            possible_moves = [move for move in possibles if dist2(move[0], move[1], vessel[0], vessel[1]) <= radius_move]
            # move vessel
            if len(possible_moves) > 0:
                position = random.choice(possible_moves)
                used[vessel[1]][vessel[0]] = False
                used[position[1]][position[0]] = True
                vessel[0], vessel[1] = position
            # TODO: end of section
            # output move
            print("M", vessel[0], vessel[1])

# choose count positions where the field is equals to character and print them
def init_positions(game_map, used, vessels, character, count):
    for _ in range(count):
        possibles = get_matching_positions(game_map, used, character, True)
        position = random.choice(possibles)
        used[position[1]][position[0]] = True
        vessels.append([position[0], position[1], False, False])
        print(position[0], position[1])

# get a list of positions where the field is equals or not equals to character
def get_matching_positions(game_map, used, character, equals):
    possible = [];
    for y, line in enumerate(game_map):
        for x, c in enumerate(line):
            if (c == character) == equals and not used[y][x]:
                possible.append([x, y])
    return possible

def dist2(x1, y1, x2, y2):
	return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)

def main():
    random.seed(42)
    is_submarine, ship_count, sub_count, radius_move, radius_view, radius_attack = map(int, input().split(' '))
    width, height = map(int, input().split(' '))
    game_map = [input() for y in range(height)]
    if is_submarine == 1:
        submarine(ship_count, sub_count, radius_move, radius_view, radius_attack, game_map)
    else:
        ship(ship_count, sub_count, radius_move, radius_view, radius_attack, game_map)

if __name__ == '__main__':
    main()
